
import Foundation

class BaseClass: Codable {}
class MyClass: BaseClass {

//This works ok:

//protocol Base: Codable {}
//class MyClass: Base {

    enum CodingKeys: String, CodingKey {
        case objectId = "id"
        case name
    }
    
    var objectId: Int = -1
    var name: String = ""
}

let dataString = "{\"id\":123,\"name\":\"test object\"}"
let data = dataString.data(using: .utf8)!

do {
    let object = try JSONDecoder().decode(MyClass.self, from: data)
    print(object.objectId) //outputs -1 or BAD_ACCESS (and not 123 as expected)
}
catch {
    print(error)
}


